/*
 * 
 * 
 * 
 * gcc -o inflate_trees_test2 inflate_trees_test2.c -Wall -ggdb -O0 -I/home/jvoss/src/zlib-1.2.5/ -L./zlib-1.2.5/ -lz
 * 
LD_LIBRARY_PATH=./zlib-1.2.5/ gdb inflate_trees_test2
(gdb) break inflate
Breakpoint 1 at 0x400790
(gdb) run zlibt2.bin 
Starting program: /home/jvoss/recent/pfm/projects/compress/unproprietary/inflate_trees_test2 zlibt2.bin
comprLen: 714

Breakpoint 1, inflate (strm=0x7fffffffd1e0, flush=0) at inflate.c:592
592     {
(gdb) break inflate_table 
Breakpoint 2 at 0x7ffff7bce855: file inftrees.c, line 107.
(gdb) c
Continuing.

Breakpoint 2, inflate_table (type=CODES, lens=0x619280, codes=19, table=0x619278, bits=0x619260, work=0x619500)
    at inftrees.c:107
107         for (len = 0; len <= MAXBITS; len++)
(gdb) print lens[0]
$1 = 4
(gdb) print lens[1]
$2 = 0
(gdb) print lens[2]
$3 = 0
(gdb) print lens[3]
$4 = 5
(gdb) print lens[4]
$5 = 2
(gdb) print lens[5]
$6 = 3
(gdb) print lens[6]
$7 = 3
(gdb) print lens[7]
$8 = 3
(gdb) print lens[8]
$9 = 3
(gdb) print lens[9]
$10 = 4
(gdb) print lens[10]
$11 = 0
(gdb) print lens[11]
$12 = 0
(gdb) print lens[12]
$13 = 0
(gdb) print lens[13]
$14 = 0
(gdb) print lens[14]
$15 = 0
(gdb) print lens[15]
$18 = 0
(gdb) print lens[16]
$19 = 6
(gdb) print lens[17]
$20 = 6
(gdb) print lens[18]
$21 = 4

Now we know what it should be. Now look at what the python impl did.
[4, 0, 0, 0, 0, 0, 4, 3, 4, 3, 3, 0, 0, 0, 0, 0, 5, 6, 6]
Totally wrong!
l 5
l 6
l 6
l 4
l 4
l 3
l 3
l 4
l 3

Not only is the order wrong, there's a missing 3.
Fixed. it was a missing bh.DROPBITS(2)...

[4, 0, 0, 5, 2, 3, 3, 3, 3, 4, 0, 0, 0, 0, 0, 0, 6, 6, 4, 0, 0, 0]

 */
#include <zlib.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

// from zlib-1.2.5/example.c

#define CHECK_ERR(err, msg) { \
    if (err != Z_OK) { \
        fprintf(stderr, "%s error: %d\n", msg, err); \
        exit(1); \
    } \
}

/* ===========================================================================
 * Test inflate() with large buffers
 */
void test_large_inflate(compr, comprLen, uncompr, uncomprLen)
    Byte *compr, *uncompr;
    uLong comprLen, uncomprLen;
{
    int err;
    z_stream d_stream; /* decompression stream */

    strcpy((char*)uncompr, "garbage");

    d_stream.zalloc = (alloc_func)0;
    d_stream.zfree = (free_func)0;
    d_stream.opaque = (voidpf)0;

    d_stream.next_in  = compr;
    d_stream.avail_in = (uInt)comprLen;

    err = inflateInit(&d_stream);
    CHECK_ERR(err, "inflateInit");

    for (;;) {
        d_stream.next_out = uncompr;            /* discard the output */
        d_stream.avail_out = (uInt)uncomprLen;
        err = inflate(&d_stream, Z_NO_FLUSH);
        if (err == Z_STREAM_END) break;
        CHECK_ERR(err, "large inflate");
    }

    err = inflateEnd(&d_stream);
    CHECK_ERR(err, "inflateEnd");

    if (d_stream.total_out != 2*uncomprLen + comprLen/2) {
        fprintf(stderr, "bad large inflate: %ld\n", d_stream.total_out);
        exit(1);
    } else {
        printf("large_inflate(): OK\n");
    }
}

int main(int argc, char **argv)
{
	Byte *compr, *uncompr;
	uLong comprLen, uncomprLen;
	if(argc < 2)
	{
		printf("Usage: inflate_trees_test2 filename\n");
		return 1;
	}
	FILE *f = fopen(argv[1], "rb");
	if(f == 0)
	{
		printf("Cannot open file %s\n", argv[1]);
		return 1;
	}
	// Temporary... or not.
	int file_size = 10000;
	compr = malloc(file_size);
	if(!compr)
	{
		perror("malloc");
		return 1;
	}
	comprLen = fread(compr, 1, 10000, f);
	printf("comprLen: %lu\n", comprLen);
	// 80k should be enough for anyone =)
	uncompr = malloc(80000);
	if(!uncompr)
	{
		perror("malloc");
		free(compr);
		return 1;
	}
	uncomprLen = 80000;
	test_large_inflate(compr, comprLen, uncompr, uncomprLen);
	return 0;
}
