#!/usr/bin/env python3
"""
Tattoo Decompressor
by Javantea
Sept 26, 2015 - Oct 6, 2015

Allows you to get the right adler32 value and the end code by trial and error.
"""
from __future__ import print_function
import zlib
import zlib_tattoo1
import find_compress1
import struct

def main():
    tattoo = b'hi there hackers!'
    # The first tattoo that worked fully in zlib_tattoo1.py
    # b'x\x9c5\x8b\xd1\n\x800\x08E\xdf\xfd+?\xe5\xda\x16Ik\x03Y\xf5\xfbi2\xd0{\x0e\xcaehi there hackers!'
    # c = b'A'
    # d = b'aidla\nanaieA\ndlaAaaA\ndlrlaAaocldtAlAao\n'
    # c+d compresses further with zlib, but no tattoo. Let's figure this out.
    # b'x\x9csL\xccL\xc9I\xe4J\xccK\xccLu\xe4\x022\x1d\x13\x13At\x11\x88\x95\x9f\x9c\x93R\xe2\x98\x03dp\x01\x00\x16\xdb\r\x9e'
    compressed = zlib_tattoo1.zlibTattoo(tattoo, '/usr/share/dict/words', 110)
    if not compressed:
        print("Zlib Tattoo is broken!")
        return 1
    #end if
    print("Zlib Tattoo!", repr(compressed))
    find_compress1.outputZlib(compressed+(b'\x00\x1f') + struct.pack('>I', 1106972353), 0)
    print("Zlib Tattoo Solved:", compressed+(b'\x00\x1f') + struct.pack('>I', 1106972353))
    # b'x\x9c5\x8b\xd1\n\x800\x08E\xdf\xfd+?\xe5\xda\x16Ik\x03Y\xf5\xfbi2\xd0{\x0e\xcaehi there hackers!\x00\x1fA\xfb\x0e\xc1'
#end def main()

if __name__ == '__main__':
    main()
#end if
